﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using MindFusion.Charting.Wpf;
using System.Windows.Media.Effects;
using System.Collections;

namespace CandlestickChart
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
		public Window1()
		{
			InitializeComponent();
			lineChart.TitleVisibility = System.Windows.Visibility.Collapsed;
			lineChart.PlotAreaMargin = new Thickness(20, 50, 20, 20);
			lineChart.XAxes[0].LabelType = LabelType.AutoScale;
			lineChart.XAxes[0].Labels.Clear();
			lineChart.XAxes[0].LabelType = LabelType.CustomText;
			lineChart.XAxes[0].CustomLabelPosition = CustomLabelPosition.AutoScalePoints;
			lineChart.XAxes[0].Labels.Add((DateTime.Now - TimeSpan.FromDays(1)).ToString("  "));
			lineChart.XAxes[0].LabelOffset = 15;
			lineChart.XAxes[0].Title = "2016";
			lineChart.XAxes[0].TitleOffset = 20;
			lineChart.XAxes[0].LabelRotationAngle = 330;
			lineChart.YAxes[0].Interval = 5000;
			lineChart.YAxes[0].TitleRotationAngle = 270;
			lineChart.YAxes[0].TitleOffset = 20;
			lineChart.YAxes[0].LabelFormat = "$ 0";

			double coef = 1000;
			Random r = new Random();
			List<StockPrice> list = new List<StockPrice>();
			for (int i = 0; i < 19; i++)
			{
				double low = i % 8 + 10;
				if (i > 7 && i < 16)
					low = 8 - i % 8 + 10;
				low += r.Next(-2, 2);
				double high = low + 10;
				double open = low + r.Next(10);
				double close = low + r.Next(10);
				DateTime d  = DateTime.Now + TimeSpan.FromDays(i);
				list.Add(new StockPrice(open * coef, close * coef, low * coef, high * coef, d));
				lineChart.XAxes[0].Labels.Add(d.ToString("MMM dd"));
			}

			CandlestickSeries series = new CandlestickSeries();
			series.Values = list;
			series.Effect = new DropShadowEffect() { Opacity = 0.3 };
			series.ToolTipType = ToolTipType.ChartData;
			series.TopLabelType = LabelType.ChartData;
			series.TopLabelFormat = "{4}";
			lineChart.Series.Add(series);
		}
    }
}
